#!/usr/bin/python
# -*- coding: utf-8 -*-
import sys
import subprocess
import re
import time

modelid = 'LPC1XXX IFLASH  '

def getDevice():
	cmd = ("lsblk -d -S -P -o NAME,MODEL,TRAN")
	cmdout = subprocess.Popen(cmd, stdout=subprocess.PIPE,shell=True).stdout.readlines()
	out = [str(x).rstrip("\n") for x in cmdout]
	for s in out :
		m = re.search('NAME=\"(?P<name>[\w\s]+)\"\sMODEL=\"(?P<model>[\w\s]+)\"\sTRAN=\"(?P<tran>[\w\s]+)\"',s)
		if m.group('tran') == 'usb' and m.group('model') == modelid :
			return('/dev/'+m.group('name'))
	return(None)

def main(filename):
	dev = getDevice()
	if dev is None :
		print "No mbed device"
		exit()
	print "mbed device is "+dev
	# アンマウント
	cmd = "umount "+dev
	print cmd
	cmdout = subprocess.Popen(cmd, stdout=subprocess.PIPE,shell=True).stdout.readlines()
	# ddコマンドで書き込み
	cmd = "dd if="+filename+" of="+dev+" seek=4"
	print cmd
	cmdout = subprocess.Popen(cmd, stdout=subprocess.PIPE,shell=True).stdout.readlines()

if __name__ == '__main__':
	if len(sys.argv) == 2 :
		main(sys.argv[1])
	else :
		print u'''
このスクリプトはlinux上でのmbed(LPC11U35マイコンボード)への書き込みツールです。
LPC11U35マイコンボードのデバイスファイルを探して、unmountし、ファイルの
先頭４ブロックを除いてddコマンドで書き込みます。
LPC11U35マイコンボードをLinux上で認識させた状態で以下のコマンドを実行して下さい。
使い方：
  $ sudo python write_mbed.py [バイナリファイル名]
注意）このスクリプトは無保証です。
'''
